﻿Imports System.IO
Imports System.Text

Public Class CEcoIrisCard
    Inherits List(Of IrisCardElm)

    Public Class IrisCardElm
        Public ID As String
        Public PictID As String
        Public Name As String
        Public CardNo As String
        Public HolderPage As String
        Public Order As Integer
        Public Rare As Integer
        Public Original As IrisCardElm  ' アセンブルの元カード
        Public AssembleCount As Integer
        Public PosWeapon As Boolean
        Public PosArmer As Boolean
        Public PosBreast As Boolean
        Public Attribute(6) As Integer  ' 無 火 水 風 土 光 闇
        Public AbilityVectorID(2) As String
        Public AbilityValue(2) As Integer
        Public LimitText As String
        Public FlavorText As String
        Public Illustrator As String

        Public Derivative As List(Of IrisCardElm) = New List(Of IrisCardElm)()

    End Class


    ''' <summary>
    ''' 初期化
    ''' </summary>
    ''' <param name="RootPath"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    Public Function Initialize(ByVal RootPath As String) As Boolean
        Dim Result As Integer
        Dim size As Integer
        Result = LibEcoDr.TestNamedDatFileW(LibEcoDr.FileIndex.ARCHIVE_XLS_TABLE, "iris_card.csv", size)
        If Result = 0 Then
            MessageBox.Show("iris_card.csvの読み込みに失敗しました。", "エラー", MessageBoxButtons.OK)
            Return False
        End If

        Dim Data(size) As Byte
        LibEcoDr.GetReadBuffer(Data, size)
        Dim ms As MemoryStream = New MemoryStream(Data)
        Dim Reader As FileIO.TextFieldParser = New FileIO.TextFieldParser(ms, Encoding.GetEncoding("SJIS"))

        Reader.TextFieldType = FileIO.FieldType.Delimited
        Reader.SetDelimiters(",")

        While Reader.EndOfData = False
            Try
                Dim cr() As String = Reader.ReadFields()
                ' 要素数が47以上かつコメント行でなく、アセンブルでない場合は追加
                If cr.Length >= 47 AndAlso cr(0).Chars(0) <> "#"c AndAlso cr(0) = cr(9) Then
                    ' 要素を設定
                    Dim Elm As IrisCardElm = New IrisCardElm()

                    Elm.ID = cr(0)
                    Elm.PictID = cr(1)
                    Elm.Name = cr(3)
                    Elm.CardNo = cr(5)
                    Elm.HolderPage = cr(6)
                    Elm.LimitText = cr(44)
                    Elm.FlavorText = cr(45)
                    Elm.Illustrator = cr(46)

                    Me.Add(Elm)
                End If

            Catch ex As Exception
                MessageBox.Show(ex.Message)
                Return False

            End Try
        End While

        Return True
    End Function

End Class
