﻿Imports System.IO

Public Class IrisForm

    Private m_EcoRootPath As String
    Private m_IrisCard As CEcoIrisCard

    ' アプリケーション初期化
    Private Function InitApp() As Boolean
        ' プログラムフォルダを決定
        'm_EcoRootPath = Path.Combine(My.Computer.FileSystem.SpecialDirectories.ProgramFiles, "GungHo\Emil chronicle online")
        m_EcoRootPath = My.Settings.EcoPath

        Dim Success As Boolean = False
        While (Success = False)
            Dim EcoExecFile As String = Path.Combine(m_EcoRootPath, "eco.exe")

            Success = File.Exists(EcoExecFile)

            If Success Then
                If LibEcoDr.InitializeW(m_EcoRootPath) = 0 Then
                    MessageBox.Show("ファイル読み込みライブラリの初期化に失敗しました。", "エラー", MessageBoxButtons.OK)
                    Success = False
                End If
            End If

            If Success Then
                ' ファイルが見つかった場合
                'Success = True
                'Exit While
            Else
                ' ファイルが見つからない場合
                Dim ofd As OpenFileDialog = New OpenFileDialog()
                ofd.CheckFileExists = True
                ofd.Filter = "Exe File (*.exe)|*.exe||"

                If ofd.ShowDialog() = DialogResult.OK Then
                    m_EcoRootPath = Path.GetDirectoryName(ofd.FileName)
                Else
                    ' ファイルの選択をキャンセルした場合
                    Return False
                End If
            End If
        End While

        m_IrisCard = New CEcoIrisCard()
        m_IrisCard.Initialize(m_EcoRootPath)

        Return True
    End Function

    Private Sub IrisForm_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        If m_IrisCard Is Nothing Then
            If InitApp() Then
                SetList()
                Me.PrimaryListView.Items(18).Selected = True

            Else
                ' エラー時終了
                Close()
            End If
        End If
    End Sub

    ' カード選択変更時
    Private Sub PrimaryListView_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrimaryListView.SelectedIndexChanged
        If Me.PrimaryListView.SelectedItems.Count > 0 Then
            Dim CardElm As CEcoIrisCard.IrisCardElm = DirectCast(Me.PrimaryListView.SelectedItems(0).Tag, CEcoIrisCard.IrisCardElm)

            Dim Filename As String
            Filename = CardElm.PictID & "iris_l.png"
            ' 画像読み込み
            Dim FileSize As Integer = 0
            Dim Result As Integer
            Result = LibEcoDr.TestNamedDatFileW(LibEcoDr.FileIndex.ARCHIVE_SPRITE_IRISCARD, Filename, FileSize)

            If Result <> 0 Then
                Dim Data(FileSize) As Byte
                LibEcoDr.GetReadBuffer(Data, FileSize)
                Dim ms As MemoryStream = New MemoryStream(Data)
                Dim bm As Bitmap = New Bitmap(ms)
                Me.PictureBox1.Image = bm
                Me.PictureBox1.Refresh()
            End If

            Me.TextBox1.Text = CardElm.FlavorText.Replace("$R", vbCrLf)
            Me.TextBox1.Refresh()
        End If
    End Sub

    ' リスト設定
    Private Sub SetList()
        Try
            Me.PrimaryListView.BeginUpdate()

            Me.PrimaryListView.Items.Clear()
            For Each CardElm As CEcoIrisCard.IrisCardElm In m_IrisCard
                If CardElm.Original Is Nothing Then
                    Dim s As String = CardElm.Illustrator.ToUpper()
                    Dim LvItem As ListViewItem = New ListViewItem()

                    ' とりあえず普通に表示
                    LvItem.Text = CardElm.CardNo
                    LvItem.SubItems.Add(CardElm.Name)
                    LvItem.SubItems.Add(CardElm.Illustrator)
                    LvItem.Tag = CardElm

                    Me.PrimaryListView.Items.Add(LvItem)

                End If
            Next
        Finally
            Me.PrimaryListView.EndUpdate()

        End Try

    End Sub

    ' 列ヘッダクリック時
    Private Sub PrimaryListView_ColumnClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ColumnClickEventArgs) Handles PrimaryListView.ColumnClick
        Try
            Me.PrimaryListView.BeginUpdate()

            Me.PrimaryListView.ListViewItemSorter = New ListViewItemComparer(e.Column)

        Finally
            Me.PrimaryListView.EndUpdate()

        End Try
    End Sub

    Class ListViewItemComparer
        Implements IComparer

        Private col As Integer

        Public Sub New()
            col = 0
        End Sub

        Public Sub New(ByVal column As Integer)
            col = column
        End Sub

        Public Function Compare(ByVal x As Object, ByVal y As Object) As Integer _
           Implements IComparer.Compare
            Return [String].Compare(CType(x, ListViewItem).SubItems(col).Text, CType(y, ListViewItem).SubItems(col).Text)
        End Function
    End Class

End Class
