﻿Imports System.Runtime.InteropServices

Public Class LibEcoDr

    ''' <summary>
    ''' 初期化処理
    ''' </summary>
    ''' <param name="EcoAppPath"></param>
    ''' <returns>0:エラー、1:正常完了</returns>
    ''' <remarks>
    ''' ファイルパスが正しくないか、対象が最新クライアントでない場合はエラーとなる。
    ''' </remarks>
    <DllImport("LibEcoDr", CharSet:=CharSet.Unicode)> _
    Public Shared Function InitializeW(ByVal EcoAppPath As String) As Integer
    End Function

    ''' <summary>
    ''' ファイル読み込みテスト
    ''' </summary>
    ''' <param name="FileIndex">ファイルインデックス</param>
    ''' <param name="Filename">ファイル名</param>
    ''' <param name="FileSize">(戻り)展開後のサイズ</param>
    ''' <returns>0:失敗、1:成功</returns>
    ''' <remarks></remarks>
    <DllImport("LibEcoDr", CharSet:=CharSet.Unicode)> _
    Public Shared Function TestNamedDatFileW(ByVal FileIndex As Integer, ByVal Filename As String, ByRef FileSize As Integer) As Integer
    End Function

    ''' <summary>
    ''' アーカイブファイル数取得
    ''' </summary>
    ''' <returns>下記のFILE_COUNT</returns>
    ''' <remarks>FileIndexにはこの値-1までの値を指定できる</remarks>
    <DllImport("LibEcoDr")> _
    Public Shared Function GetFileCount() As Integer
    End Function

    ''' <summary>
    ''' 読み込みバッファ取得
    ''' </summary>
    ''' <param name="recieve">受け取りバッファ</param>
    ''' <param name="size">受け取りバッファのサイズ</param>
    ''' <remarks>実際にはDLL側ではrecieveにコピーを行う。</remarks>
    <DllImport("LibEcoDr")> _
    Public Shared Sub GetReadBuffer(ByVal recieve As Byte(), ByVal size As Integer)
    End Sub

    ''' <summary>
    ''' DATファイル名取得
    ''' </summary>
    ''' <param name="Index"></param>
    ''' <returns></returns>
    ''' <remarks></remarks>
    <DllImport("LibEcoDr", CharSet:=CharSet.Unicode)> _
    Public Shared Function GetDatFilenameW(ByVal Index As Integer) As String
    End Function

    ''' <summary>
    ''' ファイルインデックス定数
    ''' </summary>
    ''' <remarks></remarks>
    Public Enum FileIndex As Integer
        ARCHIVE_XLS_TABLE = 1
        ARCHIVE_MAP_ATTR = 7
        ARCHIVE_MAP_TEX = 8
        ARCHIVE_MAP_MRB = 9
        ARCHIVE_MAP_CT = 10
        ARCHIVE_MAPOBJ_ATTR = 11
        ARCHIVE_MAPOBJ_TEX = 12
        ARCHIVE_MAPOBJ_MRB = 13
        ARCHIVE_MAPOBJ_CT = 14
        ARCHIVE_CHARA_ATTR = 15
        ARCHIVE_CHARA_TEX = 16
        ARCHIVE_CHARA_MRB = 17
        ARCHIVE_CHARA_ANIM = 18
        ARCHIVE_CHARA_CT = 19
        ' エフェクト
        ARCHIVE_EFFECT_ATTR = 20
        ARCHIVE_EFFECT_TEX = 21
        ARCHIVE_EFFECT_MRB = 22
        ARCHIVE_EFFECT_CT = 23

        ARCHIVE_MONSTER_ATTR = 24
        ARCHIVE_MONSTER_TEX = 25
        ARCHIVE_MONSTER_MRB = 26
        ARCHIVE_MONSTER_ANIM = 27
        ARCHIVE_NPC_ATTR = 28
        ARCHIVE_NPC_TEX = 29
        ARCHIVE_NPC_MRB = 30
        ARCHIVE_NPC_ANIM = 31
        ARCHIVE_MARIONETTE_ATTR = 32
        ARCHIVE_MARIONETTE_TEX = 33
        ARCHIVE_MARIONETTE_MRB = 34
        ARCHIVE_MARIONETTE_ANIM = 35
        ' マップその他はパス
        ARCHIVE_OTHER_ATTR = 42
        ARCHIVE_OTHER_TEX = 43
        ARCHIVE_OTHER_MRB = 44
        ARCHIVE_OTHER_ANIM = 45
        ARCHIVE_OTHER_CT = 46
        ARCHIVE_CHARA2_ATTR = 47
        ARCHIVE_CHARA2_TEX = 48
        ARCHIVE_CHARA2_MRB = 49
        ARCHIVE_CHARA2_ANIM = 50
        ARCHIVE_FURNITURE_ATTR = 51
        ARCHIVE_FURNITURE_TEX = 52
        ARCHIVE_FURNITURE_MRB = 53
        ARCHIVE_FURNITURE_ANIM = 54
        ARCHIVE_FURNITURE_CT = 55
        ARCHIVE_CHARA3_ATTR = 56
        ARCHIVE_CHARA3_TEX = 57
        ARCHIVE_CHARA3_MRB = 58
        ARCHIVE_CHARA3_ANIM = 59
        ARCHIVE_CHARA4_ATTR = 60
        ARCHIVE_CHARA4_TEX = 61
        ARCHIVE_CHARA4_MRB = 62
        ARCHIVE_CHARA4_ANIM = 63
        ARCHIVE_FACE_ATTR = 64
        ARCHIVE_FACE_TEX = 65
        ARCHIVE_FACE_MRB = 66
        ARCHIVE_FACE_ANIM = 67
        ARCHIVE_CHARA5_ATTR = 68
        ARCHIVE_CHARA5_TEX = 69
        ARCHIVE_CHARA5_MRB = 70
        ARCHIVE_CHARA5_ANIM = 71
        ARCHIVE_CHARA6_ATTR = 72
        ARCHIVE_CHARA6_TEX = 73
        ARCHIVE_CHARA6_MRB = 74
        ARCHIVE_CHARA6_ANIM = 75
        ARCHIVE_FACE2_ATTR = 76
        ARCHIVE_FACE2_TEX = 77
        ARCHIVE_FACE2_MRB = 78
        ARCHIVE_FACE2_ANIM = 79
        ARCHIVE_CHARA7_ATTR = 80
        ARCHIVE_CHARA7_TEX = 81
        ARCHIVE_CHARA7_MRB = 82
        ARCHIVE_CHARA7_ANIM = 83
        ARCHIVE_CHARA8_ATTR = 84
        ARCHIVE_CHARA8_TEX = 85
        ARCHIVE_CHARA8_MRB = 86
        ARCHIVE_CHARA8_ANIM = 87
        ARCHIVE_FACE3_ATTR = 88
        ARCHIVE_FACE3_TEX = 89
        ARCHIVE_FACE3_MRB = 90
        ARCHIVE_FACE3_ANIM = 91
        ARCHIVE_CHARA9_ATTR = 92
        ARCHIVE_CHARA9_TEX = 93
        ARCHIVE_CHARA9_MRB = 94
        ARCHIVE_CHARA9_ANIM = 95
        ARCHIVE_MONSTER2_ATTR = 96
        ARCHIVE_MONSTER2_TEX = 97
        ARCHIVE_MONSTER2_MRB = 98
        ARCHIVE_MONSTER2_ANIM = 99
        ARCHIVE_CHARA10_ATTR = 100
        ARCHIVE_CHARA10_TEX = 101
        ARCHIVE_CHARA10_MRB = 102
        ARCHIVE_CHARA10_ANIM = 103
        ARCHIVE_SPRITE_IRISCARD = 104

        FILE_COUNT = 104
    End Enum

End Class
